extern int ShortMA = 8;
extern int LongMA = 13;
extern double Lots=0.1;
extern double TakeProfit=250.0;
extern double TrailingStop=35.0;

int init()     //Initialisation
  {
   Comment("");
   return(0);
  }

int deinit()     //Deinitialisation
  {
   Comment("");
   return(0);
  }

int start()     //The main function
{
   int cnt, ticket, total;
   double shortEma, longEma;
   
   if (Bars < 100) return(0);
   
   shortEma = iMA(NULL, 0, ShortMA, 0, MODE_EMA, PRICE_CLOSE, 0);
   longEma = iMA(NULL, 0, LongMA, 0, MODE_EMA, PRICE_CLOSE, 0);
   
   total = OrdersTotal();
   if (/*total < 1 &&*/ isNewBar())
   {
      if (Crossed(shortEma, longEma) == 1)
      {
         ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, 0, 0, "Buy", 12345, 0, Green);
         if (ticket > 0)
         {
            if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) Print("BUY order opened : ", OrderOpenPrice());
         }
         else Print("Error opening BUY order : ", GetLastError());
         return(0);
      }
      if(Crossed(shortEma, longEma) == 2)
      {
         ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, 3, 0, 0, "Sell", 12345, 0, Red);
         if (ticket > 0)
         {
            if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) Print("SELL order opened : ", OrderOpenPrice());
         }
         else Print("Error opening SELL order : ", GetLastError()); 
         return(0);
      }
      return(0);
   }
   
   for (cnt = 0; cnt < total; cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderType() <= OP_SELL && OrderSymbol() == Symbol())
      {
         if (OrderType() == OP_BUY)   //long position
         {
            if (Crossed(shortEma, longEma) == 2)
            {
               OrderClose(OrderTicket() ,OrderLots(), Bid, 3, Violet); // close position
               return(0);
            }
            if (TrailingStop > 0)
            {
               if (Bid - OrderOpenPrice() > TrailingStop * Point)
               {
                  if (OrderStopLoss() < Bid - TrailingStop * Point)
                  {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - TrailingStop * Point, OrderTakeProfit(), 0, Green);
                     return(0);
                  }
               }
            }
         }
         else   //short position
         {
            if (Crossed(shortEma, longEma) == 1)
            {
               OrderClose(OrderTicket(), OrderLots(), Ask, 3, Violet); // close position
               return(0);
            }
            if (TrailingStop > 0)
            {
               if (OrderOpenPrice() - Ask > TrailingStop * Point)
               {
                  if ((OrderStopLoss() > (Ask + TrailingStop * Point)) || OrderStopLoss() == 0)
                  {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + TrailingStop * Point, OrderTakeProfit(), 0, Red);
                     return(0);
                  }
               }
            }
         }
      }
   }
   
   return(0);
}

int Crossed(double Line1, double Line2)
{
   static int LastDirection = 0;
   static int CurrentDirection = 0;
   
   if (Line1 > Line2) CurrentDirection = 1; //up
   if (Line1 < Line2) CurrentDirection = 2; //down
   
   if (CurrentDirection != LastDirection)
   {
      LastDirection = CurrentDirection;
      return (LastDirection);
   }
   else return(0);
}

bool isNewBar()
{
   static datetime NewTime = 0;
   bool NewBar = false;
   if (NewTime != Time[0])
   {
      NewTime = Time[0];
      NewBar = true;
   }
   return (NewBar);
}